import unit4.collectionsLib.*;
public class TreeByTravers<T>{
  private List<T> preOrder;
  private List<T> inOrder;
  
  public TreeByTravers(T x){
    this.preOrder=new List<T>();
    this.inOrder=new List<T>();
    this.preOrder.insert(null,x);
    this.inOrder.insert(null,x);
  }
  
  public TreeByTravers(List<T> pre, List<T> in){
    this.preOrder=pre;
    this.inOrder=in;
  }
  
 
   public TreeByTravers(TreeByTravers<T> left, T x, TreeByTravers<T>right){
    
    this.preOrder=new List<T>();
    this.preOrder.insert(null,x);
    List<T> lp,li;
    if(left==null){  lp=new List<T>(); li=new List<T>();}
     else { lp=left.preOrder; li=left.inOrder;}
    List<T> rp,ri;
    if(right==null){  rp=new List<T>(); ri=new List<T>();}
     else { rp=right.preOrder; ri=right.inOrder;}
     
   
    this.preOrder=copyToEnd(this.preOrder, lp);
    this.preOrder=copyToEnd(this.preOrder, rp);
  
     this.inOrder=new List<T>();
     List<T> temp=new List<T>();
     temp.insert(null,x);
     
     this.inOrder=copyToEnd(this.inOrder,li);
    this.inOrder=copyToEnd(this.inOrder,temp);
    this.inOrder=copyToEnd(this.inOrder, ri);
  
   }
    
    public List<T> getPreOrder(){
     return this.preOrder;
  }
  
   public List<T> getInOrder(){
    return this.inOrder;
  }
   
   
   public T getInfo(){
      return this.preOrder.getFirst().getInfo();
   }
   
   public TreeByTravers<T> getLeft(){
    
    T x=this.preOrder.getFirst().getInfo();
     int numPos=numPosInList(this.inOrder, x);
   
    List<T> leftPreOrder=copyUntil(this.preOrder, numPos);
    leftPreOrder.remove(leftPreOrder.getFirst());
       
    List<T> leftInOrder=copyUntil(this.inOrder,numPos-1);
      
    if(leftPreOrder.isEmpty()|| leftInOrder.isEmpty())return null; 
      else return new TreeByTravers<T>(leftPreOrder,leftInOrder);
  }
   
   public  TreeByTravers<T> getRight(){
    
    T x=this.preOrder.getFirst().getInfo();
     int numPos=numPosInList(this.inOrder, x);
     
    List<T> rightPreOrder=copyFrom(this.preOrder,numPos);
    
    List<T> rightInOrder=copyFrom(this.inOrder,numPos);  
    
    if(rightPreOrder.isEmpty()|| rightInOrder.isEmpty()) return null;
     else return new TreeByTravers<T>(rightPreOrder, rightInOrder);
  }
   
   public void setLeft(TreeByTravers<T> left){
     T x=this.preOrder.getFirst().getInfo();
     List<T>temp=new List<T>();
     temp.insert(null,x);
     
     int numPos=numPosInList(this.inOrder, x);
     List<T> rightPreOrder=copyFrom(this.preOrder,numPos);
     List<T> rightInOrder=copyFrom(this.inOrder,numPos);  
 
    List<T> lp,li;
    if(left==null){  lp=new List<T>(); li=new List<T>();}
     else { lp=left.preOrder; li=left.inOrder;}
   
     
     List<T>newPreOrder=copyToEnd(temp, lp);
     this.preOrder=copyToEnd(newPreOrder, rightPreOrder);
    
     List<T>newInOrder=copyToEnd(li,temp);
     this.inOrder=copyToEnd(newInOrder,rightInOrder);
   }
   
   public void setRight(TreeByTravers<T> right){
     T x=this.preOrder.getFirst().getInfo();
     List<T>temp=new List<T>();
     temp.insert(null,x);
     
     int numPos=numPosInList(this.inOrder, x);
   
    List<T> leftPreOrder=copyUntil(this.preOrder, numPos);
    leftPreOrder.remove(leftPreOrder.getFirst());
       
    List<T> leftInOrder=copyUntil(this.inOrder,numPos-1);
    
     List<T> rp,ri;
    if(right==null){  rp=new List<T>(); ri=new List<T>();}
     else { rp=right.preOrder; ri=right.inOrder;}
     
    List<T>newPreOrder=copyToEnd(temp, leftPreOrder);
     this.preOrder=copyToEnd(newPreOrder, rp);
    
     List<T>newInOrder=copyToEnd(leftInOrder,temp);
     this.inOrder=copyToEnd(newInOrder,ri);
   }
   
   
   
   
   public  BinTreeNode<T> buildPreIn(){

    T x=this.preOrder.getFirst().getInfo();
   
    BinTreeNode<T> left;
    if(this.getLeft()==null)left=null;
            else left=this.getLeft().buildPreIn();
    BinTreeNode<T> right;
    if(this.getRight()==null)right=null;
     else right=this.getRight().buildPreIn();
    
    return new BinTreeNode<T>(left, x, right);
  }
 //++++++++++++++++++++++++++++++ 
   public boolean isLeaf(){
     return countList(this.preOrder)==1;
   }
   
   public int countNodes(){
     return countList(this.preOrder);
   }
 
   //+++++++++++++++++
    private  int countList(List<T> lst){
    int c=0;
    Node<T> pos=lst.getFirst();
    while(pos!=null )
    {
      c++; 
      pos=pos.getNext();
    }
     return c;
  }
   
   private  List<T> copyUntil(List<T> lst, int posNumber){
    List<T> temp=new List<T>();
    Node<T> pos=lst.getFirst();
    Node<T> p=temp.getFirst();
    int c=0;
    while(c<posNumber){
      p=temp.insert(p,pos.getInfo());
      pos=pos.getNext();
      c++;
    }
    return temp;
  }
   
   private  List<T> copyFrom(List<T> lst, int posNumber){
    List<T> temp=new List<T>();
    Node<T> pos=lst.getFirst();
    Node<T> p=temp.getFirst();
    int c=0;
    while(c<posNumber){
     pos=pos.getNext();
      c++;
    }
    while(pos!=null){
      p=temp.insert(p,pos.getInfo());
      pos=pos.getNext();
    }
    return temp;
  }
    
   private  int numPosInList(List<T> lst, T x){
    int c=1;
    Node<T> pos=lst.getFirst();
    while(pos!=null && !pos.getInfo().equals(x))
    {
      c++; 
      pos=pos.getNext();
    }
    if(pos==null)return -1; else return c;
  }
   
   
   private List<T> copyToEnd(List<T> first, List<T> second){
     List<T> temp=new List<T>();
     Node<T> pTemp=temp.getFirst();
     
     Node<T> p=first.getFirst();
       while(p!=null){
          T x=p.getInfo();
          pTemp=temp.insert(pTemp,x);
          p=p.getNext();
       }
      p=second.getFirst();
       while(p!=null){
          T x=p.getInfo();
          pTemp=temp.insert(pTemp,x);
          p=p.getNext();
       }
   return temp;
   }
   
 
}